package weblog;

import java.util.Enumeration;
import weblog.business.apis.EntriesReader;

public class LogHandler {

   private EntriesReader reader;
   private String[] levels;
   
   public LogHandler(EntriesReader _reader) {
      this(_reader, new String[]{"default"});
   }

   public LogHandler(EntriesReader _reader, String[] _levels) {
      reader = _reader;
      levels = _levels;
   }

   public Enumeration getEntries() {
      return reader.getEntries();
   }

   public String[] getLevels() {
      return levels;
   }

   public void addEntry(String _entry, String _level) {
      reader.addEntry("["+_level+"] "+_entry);
   }

}
