package org.objectweb.jonathan.libs.kernel.decoders;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Element;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;
import org.objectweb.jonathan.apis.kernel.decoders.File2Configuration;
import org.objectweb.jonathan.libs.kernel.JConfigurationFactory;

import junit.framework.*;

public class SetterTest extends TestCase {

   Context theContext = null;

   public SetterTest(String name){
      super(name);
      theContext = this.getContext();
   }

   public static void main(String args[]) {
		junit.textui.TestRunner.run(SetterTest.class);
	}
	
   public void testCircularity(){
      ObjectA $a = null;
      ObjectB $b = null;
      ObjectC $c = null;

      Object $found = theContext.getValue("maConfig/objectA",'/');
      if ($found instanceof ObjectA){
         $a = (ObjectA)$found;
      }
      $found = theContext.getValue("maConfig/objectB",'/');
      if ($found instanceof ObjectB){
         $b = (ObjectB)$found;
      }
      $found = theContext.getValue("maConfig/objectC",'/');
      if ($found instanceof ObjectC){
         $c = (ObjectC)$found;
      }

      assert($a != null);
      assert($b != null);
      assert($c != null);

   }
   
   public Context getContext() {
      try {
         
         Context $initial_context = BootKernel.newConfiguration(SetterTest.class);
         ClassPathFinder $finder = (ClassPathFinder) $initial_context.getValue("classpath_finder",(char) 0);
         File2Configuration $decoder = (File2Configuration) 
            $initial_context.getValue("jonathan/decoders/OpenXMLDecoder/instance",'/');
      
         JConfigurationFactory $context_factory = new JConfigurationFactory();
      
         Context $context = $context_factory.newContext(null,$finder);
      
         $decoder.importElement($context,
                                "org/objectweb/jonathan/libs/kernel/decoders/setter.kcf",
                                $context_factory,
                                $finder);
         return $context;
      } catch (Exception e) {
         e.printStackTrace();
         return null;
      }
   }
}
