package org.objectweb.jonathan.libs.kernel.decoders;

import junit.framework.*;

//import org.objectweb.jonathan.apis.kernel.Kernel;
import org.objectweb.jonathan.libs.kernel.Kernel;
import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Element;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;
import org.objectweb.jonathan.apis.kernel.decoders.File2Configuration;
//import org.objectweb.jonathan.apis.resources.Scheduler;

import org.objectweb.jonathan.libs.kernel.JConfigurationFactory;
import org.objectweb.jonathan.libs.kernel.JComponent;

import java.util.Enumeration;


public class XMLIncludeDecoderTest extends TestCase {

   public XMLIncludeDecoderTest(String name) {
      super(name);
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(XMLIncludeDecoderTest.class);
	}

   public void testImportXMLWithPropInclude() {
      try {
         Context $initial_context = Kernel.newConfiguration(XMLIncludeDecoderTest.class);

         ClassPathFinder $finder = (ClassPathFinder) $initial_context.getValue("classpath_finder",(char) 0);
         File2Configuration $decoder = (File2Configuration) 
            $initial_context.getValue("jonathan/decoders/OpenXMLDecoder/instance",'/');

         
         JConfigurationFactory $context_factory = new JConfigurationFactory();

         Context $context = $context_factory.newContext(null,$finder);
         $decoder.importElement($context,
                                "org/objectweb/jonathan/libs/kernel/decoders/Include2.xml",
                                $context_factory,
                                $finder);

         //From prop1.properties:
         Object $found = $context.getValue("SameLevel/prop2",'/');
         assert($found instanceof String);
         String $component = (String)$found;
         assert("SameLevel/prop2 is not value2.",$component.equals("value2"));

         $found = $context.getValue("SameLevel/prop3",'/');
         assert($found instanceof String);
         $component = (String)$found;
         assert("SameLevel/prop3 is not 45.",$component.equals("45"));

         $found = $context.getValue("SameLevel/prop5",'/');
         assert($found instanceof String);
         $component = (String)$found;
         assert("SameLevel/prop5 is not 5.2.",$component.equals("5.2"));

         //From prop2.properties:
         $found = $context.getValue("Mapping/prop",'/');
         assert("Mapping/prop is not a Context.",$found instanceof Context);

         $found = $context.getValue("Mapping/prop/c",'/');
         assert("Mapping/prop/c is not a Context.",$found instanceof Context);
         
         $found = $context.getValue("Mapping/prop/b",'/');
         assert($found instanceof String);
         $component = (String)$found;
         assert("Mapping/prop/b is not value2.",$component.equals("value2"));

         //From prop3.properties:
         $found = $context.getValue("NoMapping/prop/b",'/');
         assert("NoMapping/prop/b exists!",$found == Context.NO_VALUE);

         $found = $context.getValue("NoMapping/prop.b",'/');
         assert($found instanceof String);
         $component = (String)$found;
         assert("NoMapping/prop.b is not value2.",$component.equals("value2"));

         $found = $context.getValue("NoMapping/prop/c",'/');
         assert("NoMapping/prop/c exists!",$found == Context.NO_VALUE);
         $found = $context.getElement("NoMapping/prop/c",'/');
         assert("NoMapping/prop/c exists!",$found == null);

         $found = $context.getValue("NoMapping/prop.c",'/');
         assert($found instanceof String);
         $component = (String)$found;
         assert("NoMapping/prop.c is not 5.2.",$component.equals("5.2"));

         $found = $context.getValue("NoMapping/prop/c/e",'/');
         assert("NoMapping/prop/c/e exists!",$found == Context.NO_VALUE);
         $found = $context.getElement("NoMapping/prop/c/e",'/');
         assert("NoMapping/prop/c/e element exists!",$found == null);

         $found = $context.getValue("NoMapping/prop.c.e",'/');
         assert($found instanceof String);
         $component = (String)$found;
         assert("NoMapping/prop.c.e is not true.",$component.equals("true"));

         $found = $context.getValue("NoMapping/prop",'/');
         assert("NoMapping/prop exists!",$found == Context.NO_VALUE);

      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }

}

