/***
 * Jonathan: an Open Distributed Processing Environment 
 * Copyright (C) 2001 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: jonathan@objectweb.org
 *
 * Author: Bruno Dumant
 * 
 * --------------------------------------------------------------------------
 * $Id: ConfigurationFactory.java,v 1.1.1.1 2002/08/06 13:13:46 bmi Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonathan.apis.kernel;

/** 
 * Interface for configuration factories.
 *
 * Configurations are essentially contexts providing a class finder implementation as element
 * "/class_path_finder". It can be used either to implement lazy component instanciation,
 * or to find/load classes and resources at runtime.
 */
public interface ConfigurationFactory extends ContextFactory { 

   Context newContext(ClassPathFinder class_path_finder);
   Context newContext(Context scope,ClassPathFinder class_path_finder);

}
