/***
 * Jonathan: an Open Distributed Processing Environment 
 * Copyright (C) 2002 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: jonathan@objectweb.org
 *
 * Author: Bruno Dumant
 *
 * -------------------------------------------------------------------
 * $ID$
 * -------------------------------------------------------------------
 * 
 */

package org.objectweb.jonathan.libs.kernel.decoders;

/**
 * Holds the signature (name and type) of a single method argument.
 * Used by {@link JAlternative} to hold the signature of a
 * single class constructor. Created along with its
 * <code>JAlternative</code>'s ImplicitFactory, either
 * by the application compiled configuration or by the runtime
 * {@link XMLImplicitFactoryDecoder} (if the application's XML
 * configuration has not been compiled, but is used as the XML
 * runtime configuration file instead).
 */
public class JArgument {
   public String name;
   public String type;

   /**
    * creates a new JArgument of the given argument signature.
    */
   public JArgument(String _name,String _type) {
      name = _name;
      type = _type;
   }

   public String toString() {
      return type + " " + name;
   }
}
